--[[

		Created by Halil Durak.
		For more, visit: http://www.lab.nikneym.com

]]--

nimbus={
	version   = 0.2,					-- CURRENT VERSION
	directory = "img/", 				-- you can change directory for your own use.
	format    = "png",  				-- you can change file format for your own use.
	maxTime   = 10,						-- you can change it too but i don't recommend it..
	lp		  = love.graphics,
};

nimbus.__index=nimbus;

function nimbus.new(name, frames, speed)
	local self=setmetatable({}, nimbus);

	self.name=tostring(name);
	self.frame=tonumber(frames);
	self.scene=1;
	self.time=0;
	self.speed=tonumber(speed);
	self.img={};

	for i=1, self.frame do
		i=tostring(i);

		table.insert(self.img, nimbus.lp.newImage(nimbus.directory .. self.name .. i .. "." .. nimbus.format));
	end

	return self;
end

--Still testing actually..
function nimbus.newSheet(name, frames, speed, width, height)
	local self=setmetatable({}, nimbus);

	self.name=tostring(name);
	self.frame=tonumber(frames);
	self.scene=1;
	self.time=0;
	self.speed=tonumber(speed);
	self.imgMain=nimbus.lp.newImage(nimbus.directory .. self.name .. "." .. nimbus.format);
	self.img={};

	for i=1, self.frame do
		table.insert(self.img, nimbus.lp.newQuad(width*i-width, 0, width, height, self.imgMain:getDimensions()));
	end

	return self;
end

function nimbus.update(self, dt)
	self.time=self.time+self.speed*dt;

	if self.time > nimbus.maxTime then
		self.time=0;
		self.scene=self.scene+1;
	end

	if self.scene > table.getn(self.img) then
		self.scene=1;
	end

	return self.time;
end

function nimbus.draw(self, x, y)
	if not self.imgMain then
		nimbus.lp.draw(self.img[self.scene], x, y);
	else
		love.graphics.draw(self.imgMain, self.img[self.scene], x, y);
	end
end

function nimbus.error(text, x, y)
	nimbus.lp.setColor(255, 40, 40);
	nimbus.lp.print(text, x, y);
	nimbus.lp.setColor(255, 255, 255);
end

function nimbus.debug(self, x, y)
	if self.imgMain==nil then
		nimbus.lp.setColor(255, 255, 255);
		nimbus.lp.print("Current Scene: " .. self.scene, x, y);

		nimbus.lp.print("Files: ", x, y+40);
		for i=1, 10 do
			nimbus.lp.print(nimbus.directory .. self.name .. i .. "." .. nimbus.format, x, y+15*i+40);
		end
	else
		nimbus.error("Nimbus Error: Debug mode not supported on this function.", x, y);
	end
end